const coral = @import("coral");

const std = @import("std");

pub const Effect = Handle(struct {
	fragment_spirv_ops: []const u32,
});

fn Handle(comptime HandleDesc: type) type {
	return enum (u32) {
		default,
		_,

		pub const Desc = HandleDesc;

		const Self = @This();
	};
}

pub const Texture = enum (u32) {
	default,
	backbuffer,
	_,

	pub const Desc = struct {
		format: Format,
		access: Access,

		pub const Access = union (enum) {
			static: Static,
			render: Render,

			pub const Static = struct {
				width: u16,
				data: []const coral.io.Byte,
			};

			pub const Render = struct {
				width: u16,
				height: u16,
			};
		};

		pub const Format = enum {
			rgba8,
			bgra8,

			pub fn byte_size(self: Format) usize {
				return switch (self) {
					.rgba8, .bgra8 => 4,
				};
			}
		};
	};
};

